//+------------------------------------------------------------------+
//|                                                 Filin_Martin.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict
extern double   Lots       = 0.1;
extern int      TakeProfit = 30;
extern int      Step       = 40;
extern int      Slippage   = 3;
extern int      Magic      = 1234;
extern int     RsiPeriod = 7;
extern string   Comment    = "(c) Filin 2014" ;

int ticket, otype;
double  rsi1, rsi2, TP, price;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   if (Digits == 3 ||  Digits == 5)
   {
   TakeProfit *=10;
   Step       *=10;
   }
   return(INIT_SUCCEEDED);
  }
  
  
  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
         return(0);
   
  }
  
  
  int start()
  {
  {
     rsi1= iRSI(Symbol(),0,RsiPeriod, PRICE_CLOSE,1);
     rsi2= iRSI(Symbol(),0,RsiPeriod, PRICE_CLOSE,2);
     
     if (CountTrades () == 0  && rsi1 > rsi2)
     
     {
    
     // Buy
     
        ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, Comment, Magic,0, Blue );
        if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
        
                 
                 {
                    TP = NormalizeDouble(Ask + TakeProfit * Point, Digits);
                    OrderModify(ticket, OrderOpenPrice(),0, TP,0); 
                    
                 }                  
     
     }
     else 
     if (CountTrades () == 0  && rsi1 < rsi2)
     
     {
     
     
     // Sell
     
       ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, Comment, Magic,0, Red );
        if(OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES))
        
                 
                 {
                    TP = NormalizeDouble(Bid - TakeProfit * Point, Digits);
                    OrderModify(ticket, OrderOpenPrice(),0, TP,0); 
                    
                 }     
     
     }
     {
     
     }
     
     
     if (CountTrades() > 0)
     
     
         otype = FindLastOrderType ();
         
            if (otype == OP_BUY)
            
               //     
               price = FindLastBuyPrice();
               
               if ((price - Ask)/Point >=Step)
               
               {
                    OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0,0, Comment, Magic,0, Blue ); 
                    ModifyOrders();
                  }
                                    
                  else if (otype == OP_SELL) 
                 
                  
                  //    
                price = FindLastSellPrice();

               if ((Bid - price)/Point >= Step)
               
               {
                    OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0,0, Comment, Magic,0, Red ); 
                    ModifyOrders();
               }              
              }
               
        
      return(0);  
  }
  
 
 //+----------------------------------------------------------------------------+
 void ModifyOrders()
 {
      double avg = 0;
      int count = 0;
      
      for (int i = OrdersTotal() - 1; i>=0; i--)
      {
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
               if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol())
               {
                  if (OrderType() == OP_BUY || OP_SELL)
                  {
                     avg += OrderOpenPrice();
                     count++;
                  }
              }
          }
      
      }
      
      avg = NormalizeDouble(avg/ count, Digits);
      
   for ( int i = OrdersTotal() - 1; i>=0; i--)
      {
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
               if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol())
               {
                  if (OrderType() == OP_BUY )
                 {
                     TP = NormalizeDouble(avg + TakeProfit*Point, Digits);
                     OrderModify(OrderTicket(),OrderOpenPrice(),0, TP, 0,  Yellow);
                 }
                 else
                 if (OrderType() == OP_SELL)
                 {
                     TP = NormalizeDouble(avg - TakeProfit*Point, Digits);
                     OrderModify(OrderTicket(),OrderOpenPrice(),0, TP, 0,  Yellow);
                 }
              }
          }
      
      }
 
 }
 //+----------------------------------------------------------------------------+
 int  FindLastOrderType()
 {
     
      int oticket, ticketnumber = 0, OType = 0;
      for (int i = OrdersTotal() - 1; i>=0; i--)
      
      {
            if (OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
            
            {
                  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
                  {
                        oticket = OrderTicket();
                        if (oticket > ticketnumber)
                        {
                           ticketnumber = oticket;
                           OType = OrderType();
                        }
                  
                  }
            }
      }
 return( OType );
 }
 
 //+----------------------------------------------------------------------------+
 double  FindLastBuyPrice()
 {
     
      int oticket, ticketnumber = 0;
      double oprice = 0;
      
      for (int i = OrdersTotal() - 1; i>=0; i--)
      
      {
            if (OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
            
            {
                  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == OP_BUY)
                  {
                        oticket = OrderTicket();
                        if (oticket > ticketnumber)
                        {
                           ticketnumber = oticket;
                           oprice = OrderOpenPrice();
                        }
                  
                  }
            }
      }
 return( oprice );
 }
 
 //+----------------------------------------------------------------------------+
 double  FindLastSellPrice()
 {
     
      int oticket, ticketnumber = 0;
      double oprice = 0;
      
      for (int i = OrdersTotal() - 1; i>=0; i--)
      
      {
            if (OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
            
            {
                  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic && OrderType() == OP_SELL)
                  {
                        oticket = OrderTicket();
                        if (oticket > ticketnumber)
                        {
                           ticketnumber = oticket;
                           oprice = OrderOpenPrice();
                        }
                  
                  }
            }
      }
 return( oprice );
 }
 //+----------------------------------------------------------------------------+
  int CountTrades ()
  {
   int count = 0;
   
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
       if(OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
            {
               if (OrderType() == OP_BUY || OrderType() == OP_SELL)
                  count++;
                           
            }
      
       }
   
    
    }
    return (count);
  }
  
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
